//****************************************************************************
//	aisa15w.pas
//
//	aISA-A15
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/03/05
//
//****************************************************************************

unit aisa15w;

interface

uses
	Windows;

{ Miscellaneous }
const
	AISA15_CH_MAX       = 16;								// A/Dِ
	AISA15_BUFF_PCH_MAX = 4096;				// 1ٓA/Dޯ̧MAX

{ őXbg }
const
	AISA15_MAX_SLOTS = 16;

{ _Xbgw }
const
  AISA15_SLOT_AUTO = Word(not 0);

{ G[R[h̒`}
const
	AISA15_ERR_INTERNAL				= 5100;	{ Send mail to us }
	AISA15_ERR_UNKNOWN				= 5101;	{ Help me! }
	AISA15_SUCCESS					  = 0;		{ I }
	AISA15_ERR_NO_DEVICE			= 5000;	{ No device or not an aISA-A15 }
	AISA15_ERR_RESOURCE				= 5001;	{ Resource exhaustion }
	AISA15_ERR_INVALID_ARG		=	5002;	{ Invalid argument(s) }
	AISA15_ERR_SLOT					  = 5003;	{ _Xbgԍsłi܂͌܂j}
	AISA15_ERR_CHANNEL				= 5004;	{ `lw肪sł }
	AISA15_ERR_TIMER				  = 5005;	{ ^C}lsł }
	AISA15_ERR_DMA_BUFFSIZE		=	5006;	{ DMA]TCYsł }
	AISA15_ERR_NOT_ENOUGH_MEM	=	5007;	{ \ȃmۂł܂ł }
	AISA15_ERR_DMA					  = 5008;	{ DMA͎gpł܂ }
	AISA15_ERR_NUMDATA				= 5009;	{ w肳ꂽ̃f[^obt@ɑ݂܂ }
	AISA15_ERR_NOT_CREATED		=	5010;	{ foCXNGCgĂ܂ }
	AISA15_ERR_START				  = 5011;	{ X^[gɎs܂ }
	AISA15_ERR_INVALID_FUNC		=	5012;	{ Ȋ֐Ăяoł }
	AISA15_ERR_IN_USE				  = 5013;	{ gp̃foCXł }

{ TvO[h̒` }
const							{ START  SAMPLING	TRANSFER  CLK }
	MODE_01	= 1;		{ soft	 single	  port	    --- }
	MODE_02	= 2;		{ soft	 single	  port	    EXTRG }
	MODE_03	= 3;		{ soft	 burst		port	    timer }
	MODE_04	= 4;		{ soft	 burst		port	    EXTRG }
	MODE_05	= 5;		{ soft	 burst		DMA		    timer }
	MODE_06	= 6;		{ EXIN0  single	  port	    --- }
	MODE_07	= 7;		{ EXIN0  single	  port	    EXTRG }
	MODE_08	= 8;		{ EXIN0  burst		port	    timer }
	MODE_09	= 9;		{ EXIN0  burst		port	    EXTRG }
	MODE_10	= 10;		{ EXIN0  burst		DMA		    timer }

{ bZ[W }
const
	WM_EOC						  = 0;	{ VOTvO̊ }
	WM_BUFF_HALF_FULL		= 1;	{ VxDOobt@̃n[tt }
	WM_BUFF_FULL				= 2;	{ VxDOobt@̃t }
	WM_BUFF_OVERFLOW		= 3;	{ VxDOobt@̃I[o[t[ }
	WM_SAMPLING_OVERRUN	= 4;	{ `lEI[gECNg̃I[o[ }
	WM_DMA_TC					  = 5;	{ DMA] }

{ ***** I/O\[X\ ***** }
{ YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B }
type
    TAISA15RESOURCE_NT = record
        dwIOPortBase:   DWord;      { I/O port base }
        dwIRQRegisters: DWord;      { IRQ list }
        dwNumDMAs:      DWord;      { num DMA channels }
        dwDMALst:       DWord;      { DMA list }
    end;

PAISA15RESOURCE_NT = ^TAISA15RESOURCE_NT;


{ ***** TvO[h\ ***** }
{ YfoCX̃TvO[hɊւVxD֓n߂̍\́B }
{ iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB }
type
		TAISA15MODE = record
			iChFirst: DWord;	{ TvOJn`l(0 ` 15) }
			iChLast:  DWord;	{ TvOI`l(0 ` 15) }
			cwBuffer: DWord;	{ obt@TCYi[hPʁj }
			dwTimer:  DWord;	{ ^C}l(1`50000000) }
			dwMode:   DWord;	{ 샂[h(1`10) }
    end;

PAISA15MODE = ^TAISA15MODE;

type
	{ A/Dޯ̧ }
	TADBUFF = array [1..AISA15_CH_MAX, 1..AISA15_BUFF_PCH_MAX] of Word;
	TVXDBUFF = array [1..(AISA15_CH_MAX) * (AISA15_BUFF_PCH_MAX-1)] of Word;
	PADBUFF = ^TADBUFF;
	PVXDNUFF = ^TVXDBUFF;

const
	AISA15_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA15_DLL_NAME = 'aisa15.dll';		{ DLL }


function Aisa15wDllOpen: Boolean;		{ DLL [h }
function Aisa15wDllClose: Boolean;	{ DLL A[h }


{ foCXhCoDLL̃o[W擾 }
function Aisa15wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ foCX̎gp錾 }
function Aisa15wCreate(var pwLogSlot: Word; hwnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
{ foCX̊J錾 }
function Aisa15wClose(wLogSlot: Word): Boolean;


{ I/O\[X̎擾 }
function Aisa15wGetResource(wLogSlot: Word; pres: PAISA15RESOURCE_NT): Boolean;


{ TvO[h̐ݒ }
function Aisa15wSetMode(wLogSlot: Word; pcmode: PAISA15MODE): Boolean;
{ TvOJn }
function Aisa15wStartSampling(wLogSlot: Word): Boolean;
{ TvO~ }
function Aisa15wStopSampling(wLogSlot: Word): Boolean;
{ TvOEXe[^X̎擾 }
function Aisa15wGetSamplingStatus(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Boolean;
{ TvOς݃f[^̎擾 }
function Aisa15wGetData(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Boolean;
{ O͏Ԃ̎擾 }
function Aisa15wGetExIn(wLogSlot: Word; var pdwExIn0: DWord; var pdwExIn1: DWord; var pdwExTrg: DWord): Boolean;


{ G[R[h̎擾 }
function Aisa15wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa15GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
  TAisa15Create = function(var pwLogSlot: Word; hwnd: THandle; uWMBase: UInt; var lpvInitArg): Bool; stdcall;
	TAisa15Close = function(wLogSlot: Word): Bool; stdcall;
	TAisa15GetResource = function(wLogSlot: Word; pres: PAISA15RESOURCE_NT): Bool; stdcall;
	TAisa15SetMode = function(wLogSlot: Word; pcmode: PAISA15MODE): Bool; stdcall;
	TAisa15StartSampling = function(wLogSlot: Word): Bool; stdcall;
	TAisa15StopSampling = function(wLogSlot: Word): Bool; stdcall;
	TAisa15GetSamplingStatus = function(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Bool; stdcall;
	TAisa15GetData = function(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Bool; stdcall;
	TAisa15GetExIn = function(wLogSlot: Word; var pdwExIn0: DWord; var pdwExIn1: DWord; var pdwExTrg: DWord): Bool; stdcall;
	TAisa15GetLastError = function(wLogSlot: Word): DWord; stdcall;

function Aisa15wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa15GetVersion: TAisa15GetVersion;
	pAisa15Create: TAisa15Create;
	pAisa15Close: TAisa15Close;
	pAisa15GetResource: TAisa15GetResource;
	pAisa15SetMode: TAisa15SetMode;
	pAisa15StartSampling: TAisa15StartSampling;
	pAisa15StopSampling: TAisa15StopSampling;
	pAisa15GetSamplingStatus: TAisa15GetSamplingStatus;
	pAisa15GetData: TAisa15GetData;
	pAisa15GetExIn: TAisa15GetExIn;
	pAisa15GetLastError: TAisa15GetLastError;


//****************************************************************************
// 		aisa15.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA15_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa15wGetDllExportFunc = False then
	begin
		Aisa15wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		aisa15.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;



//****************************************************************************
// 		aISA-A15 DLL,Driver̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drivero[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aISA-A15̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[
//        hWnd       bZ[W𑗂EBhEnh
//		    uWMBase	   bZ[WID
//        pvInitArg  gp
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wCreate(var pwLogSlot: Word; hwnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
end;

//****************************************************************************
// 		aISA-A15̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pres 		 \[Xi[\
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wGetResource(wLogSlot: Word; pres: PAISA15RESOURCE_NT): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15GetResource(wLogSlot, pres);
end;

//****************************************************************************
// 		TvO[h̐ݒ
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wSetMode(wLogSlot: Word; pcmode: PAISA15MODE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

  Result := pAisa15SetMode(wLogSlot, pcmode);
end;

//****************************************************************************
// 		TvOJn
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wStartSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15StartSampling(wLogSlot);
end;

//****************************************************************************
// 		TvO~
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wStopSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15StopSampling(wLogSlot);
end;

//****************************************************************************
// 		TvOEXe[^X̎擾
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wGetSamplingStatus(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus);
end;

//****************************************************************************
// 		TvOς݃f[^̎擾
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wGetData(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

  Result := pAisa15GetData(wLogSlot, cwNumData, Data);
end;

//****************************************************************************
// 		O͏Ԃ̎擾
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wGetExIn(wLogSlot: Word; var pdwExIn0: DWord; var pdwExIn1: DWord; var pdwExTrg: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

  Result := pAisa15GetExIn(wLogSlot, pdwExIn0, pdwExIn1, pdwExTrg);
end;

//****************************************************************************
// 		aISA-A15̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Aisa15wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA15_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa15GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Aisa15wGetDllExportFunc: Boolean;
begin
	Result := False;

  // Aisa15GetVersion ̃AhX擾
	pAisa15GetVersion := GetProcAddress(hDLL, 'Aisa15GetVersion');
	if @pAisa15GetVersion = nil then Exit;

  // Aisa15Create ̃AhX擾
	pAisa15Create := GetProcAddress(hDLL, 'Aisa15Create');
	if @pAisa15Create = nil then Exit;

  // Aisa15Close ̃AhX擾
	pAisa15Close := GetProcAddress(hDLL, 'Aisa15Close');
	if @pAisa15Close = nil then Exit;

  // Aisa15GetResource ̃AhX擾
	pAisa15GetResource := GetProcAddress(hDLL, 'Aisa15GetResource');
	if @pAisa15GetResource = nil then Exit;

  // Aisa15SetMode ̃AhX擾
	pAisa15SetMode := GetProcAddress(hDLL, 'Aisa15SetMode');
	if @pAisa15SetMode = nil then Exit;

  // Aisa15StartSampling ̃AhX擾
	pAisa15StartSampling := GetProcAddress(hDLL, 'Aisa15StartSampling');
	if @pAisa15StartSampling = nil then Exit;

  // Aisa15StopSampling ̃AhX擾
	pAisa15StopSampling := GetProcAddress(hDLL, 'Aisa15StopSampling');
	if @pAisa15StopSampling = nil then Exit;

  // Aisa15GetSamplingStatus ̃AhX擾
	pAisa15GetSamplingStatus := GetProcAddress(hDLL, 'Aisa15GetSamplingStatus');
	if @pAisa15GetSamplingStatus = nil then Exit;

  // Aisa15GetData ̃AhX擾
	pAisa15GetData := GetProcAddress(hDLL, 'Aisa15GetData');
	if @pAisa15GetData = nil then Exit;

  // Aisa15GetExIn ̃AhX擾
	pAisa15GetExIn := GetProcAddress(hDLL, 'Aisa15GetExIn');
	if @pAisa15GetExIn = nil then Exit;

  // Aisa15GetLastError ̃AhX擾
	pAisa15GetLastError := GetProcAddress(hDLL, 'Aisa15GetLastError');
	if @pAisa15GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

