/*****************************************************************************/
/*	aisa15w.c																 */
/*																			 */
/*	aISA-A15															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/04/21															 */
/*																			 */
/*****************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "aisa15w.h"	// aISA-A15

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Aisa15wGetDllExportFunc();

/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pAisa15GetVersion;
static FARPROC pAisa15Create;
static FARPROC pAisa15Close;
static FARPROC pAisa15GetResource;
static FARPROC pAisa15SetMode;
static FARPROC pAisa15StartSampling;
static FARPROC pAisa15StopSampling;
static FARPROC pAisa15GetSamplingStatus;
static FARPROC pAisa15GetData;
static FARPROC pAisa15GetExIn;
static FARPROC pAisa15GetLastError;


/*****************************************************************************/
/* 	  aisa15.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(AISA15_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Aisa15wGetDllExportFunc() == FALSE)
	{
		Aisa15wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  aisa15.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

/*****************************************************************************/
/* 	  aISA-A15 DLL,Driver̃o[Wԍ擾							 */
/* 	  pdwDllVer DLLo[Wԍi[AhX						 */
/*		  pdwDrvVer Drivero[Wԍi[AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa15GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aISA-A15̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSlot gpfoCXi[AhX						 */
/*		  hWnd		bZ[W𑗂EBhEnh						 */
/*		  uWMBase	bZ[WID											 */
/*		  pvInitArg gp(NULLZbg)									 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wCreate(LPWORD lpwLogSlot, HWND hWnd, UINT uWMBase, LPVOID lpvInitArg)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa15Create)(lpwLogSlot, hWnd, uWMBase, lpvInitArg);
}

/*****************************************************************************/
/* 	  aISA-A15̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa15Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot ׂfoCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wGetResource(WORD wLogSlot, PAISA15R_NT pres)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa15GetResource)(wLogSlot, pres);
}

/*****************************************************************************/
/* 	  TvO[h̐ݒ											 */
/* 	  wLogSlot ݒ肷foCX											 */
/*		  pcmode   [hݒf[^̃AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wSetMode(WORD wLogSlot, PCAISA15M pcmode)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa15SetMode)(wLogSlot, pcmode);
}

/*****************************************************************************/
/* 	  TvOJn													 */
/* 	  wLogSlot JnfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wStartSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa15StartSampling)(wLogSlot);
}

/*****************************************************************************/
/* 	  TvO~													 */
/* 	  wLogSlot ~foCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wStopSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa15StopSampling)(wLogSlot);
}

/*****************************************************************************/
/* 	  TvOEXe[^X̎擾									 */
/* 	  wLogSlot	 擾foCX										 */
/*		  pcwNumData f[^obt@AhX								 */
/*		  pdwStatus	 Xe[^XAhX										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wGetSamplingStatus(WORD wLogSlot, PDWORD pcwNumData, PDWORD pdwStatus)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa15GetSamplingStatus)(wLogSlot, pcwNumData, pdwStatus);
}

/*****************************************************************************/
/* 	  TvOς݃f[^̎擾										 */
/* 	  wLogSlot	擾foCX										 */
/*		  cwNumData vf[^											 */
/*		  pwData	f[^obt@ւ̃AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wGetData(WORD wLogSlot, DWORD cwNumData, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa15GetData)(wLogSlot, cwNumData, pwData);
}

/*****************************************************************************/
/* 	  O͏Ԃ̎擾												 */
/* 	  wLogSlot 擾foCX											 */
/*		  pdwExIn0 EXIN0̏												 */
/*		  pdwExIn1 EXIN1̏												 */
/*		  pdwExTrg EXTRG̏												 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa15wGetExIn(WORD wLogSlot, PDWORD pdwExIn0, PDWORD pdwExIn1, PDWORD pdwExTrg)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa15GetExIn)(wLogSlot, pdwExIn0, pdwExIn1, pdwExTrg);
}

/*****************************************************************************/
/* 	  aISA-A15̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Aisa15wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return AISA15_ERR_WRAPDLL;

	return (*pAisa15GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Aisa15wGetDllExportFunc()
{
	// Aisa15GetVersion ̃AhX擾
	pAisa15GetVersion = GetProcAddress(hDLL, _T("Aisa15GetVersion"));
	if (pAisa15GetVersion == NULL)
		return FALSE;

	// Aisa15Create ̃AhX擾
	pAisa15Create = GetProcAddress(hDLL, _T("Aisa15Create"));
	if (pAisa15Create == NULL)
		return FALSE;

	// Aisa15Close ̃AhX擾
	pAisa15Close = GetProcAddress(hDLL, _T("Aisa15Close"));
	if (pAisa15Close == NULL)
		return FALSE;

	// Aisa15GetResource ̃AhX擾
	pAisa15GetResource = GetProcAddress(hDLL, _T("Aisa15GetResource"));
	if (pAisa15GetResource == NULL)
		return FALSE;

	// Aisa15SetMode ̃AhX擾
	pAisa15SetMode = GetProcAddress(hDLL, _T("Aisa15SetMode"));
	if (pAisa15SetMode == NULL)
		return FALSE;

	// Aisa15StartSampling ̃AhX擾
	pAisa15StartSampling = GetProcAddress(hDLL, _T("Aisa15StartSampling"));
	if (pAisa15StartSampling == NULL)
		return FALSE;

	// Aisa15StopSampling ̃AhX擾
	pAisa15StopSampling = GetProcAddress(hDLL, _T("Aisa15StopSampling"));
	if (pAisa15StopSampling == NULL)
		return FALSE;

	// Aisa15GetSamplingStatus ̃AhX擾
	pAisa15GetSamplingStatus = GetProcAddress(hDLL, _T("Aisa15GetSamplingStatus"));
	if (pAisa15GetSamplingStatus == NULL)
		return FALSE;

	// Aisa15GetData ̃AhX擾
	pAisa15GetData = GetProcAddress(hDLL, _T("Aisa15GetData"));
	if (pAisa15GetData == NULL)
		return FALSE;

	// Aisa15GetExIn ̃AhX擾
	pAisa15GetExIn = GetProcAddress(hDLL, _T("Aisa15GetExIn"));
	if (pAisa15GetExIn == NULL)
		return FALSE;

	// Aisa15GetLastError ̃AhX擾
	pAisa15GetLastError = GetProcAddress(hDLL, _T("Aisa15GetLastError"));
	if (pAisa15GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
